Index: src/main/java/org/jboss/dna/jcr/JcrWorkspace.java
===================================================================
--- src/main/java/org/jboss/dna/jcr/JcrWorkspace.java	(revision 1377)
+++ src/main/java/org/jboss/dna/jcr/JcrWorkspace.java	(working copy)
@@ -38,7 +38,6 @@
 import javax.jcr.PathNotFoundException;
 import javax.jcr.RepositoryException;
 import javax.jcr.Session;
-import javax.jcr.UnsupportedRepositoryOperationException;
 import javax.jcr.Workspace;
 import javax.jcr.lock.Lock;
 import javax.jcr.lock.LockException;
@@ -131,6 +130,11 @@
      * Reference to the JCR query manager for this workspace.
      */
     private final JcrQueryManager queryManager;
+    
+    /**
+     * Reference to the JCR observation manager for this workspace.
+     */
+    private final JcrObservationManager observationManager;
 
     private final WorkspaceLockManager lockManager;
 
@@ -166,6 +170,7 @@
         // This must be initialized after the session
         this.nodeTypeManager = new JcrNodeTypeManager(session, this.repository.getRepositoryTypeManager());
         this.queryManager = new JcrQueryManager(this.session);
+        this.observationManager = new JcrObservationManager(this.session, this.repository.getRepositoryObservable());
 
         // if (Boolean.valueOf(repository.getOptions().get(Option.PROJECT_NODE_TYPES))) {
         // Path parentOfTypeNodes = context.getValueFactories().getPathFactory().create(systemPath, JcrLexicon.NODE_TYPES);
@@ -197,6 +202,10 @@
         return this.lockManager;
     }
 
+    final JcrObservationManager observationManager() {
+        return this.observationManager;
+    }
+    
     /**
      * {@inheritDoc}
      */
@@ -252,9 +261,11 @@
 
     /**
      * {@inheritDoc}
+     *
+     * @see javax.jcr.Workspace#getObservationManager()
      */
-    public final ObservationManager getObservationManager() throws UnsupportedRepositoryOperationException {
-        throw new UnsupportedRepositoryOperationException();
+    public final ObservationManager getObservationManager() {
+        return this.observationManager;
     }
 
     /**
Index: src/main/java/org/jboss/dna/jcr/JcrEngine.java
===================================================================
--- src/main/java/org/jboss/dna/jcr/JcrEngine.java	(revision 1377)
+++ src/main/java/org/jboss/dna/jcr/JcrEngine.java	(working copy)
@@ -163,7 +163,8 @@
         String sourceName = context.getValueFactories().getStringFactory().create(property.getFirstValue());
 
         // Create the repository ...
-        JcrRepository repository = new JcrRepository(context, connectionFactory, sourceName, descriptors, options);
+        JcrRepository repository = new JcrRepository(context, connectionFactory, sourceName,
+                                                     getRepositoryService().getRepositoryLibrary(), descriptors, options);
 
         // Register all the the node types ...
         Node nodeTypesNode = subgraph.getNode(JcrLexicon.NODE_TYPES);
Index: src/main/java/org/jboss/dna/jcr/JcrNodeTypeManager.java
===================================================================
--- src/main/java/org/jboss/dna/jcr/JcrNodeTypeManager.java	(revision 1377)
+++ src/main/java/org/jboss/dna/jcr/JcrNodeTypeManager.java	(working copy)
@@ -39,6 +39,7 @@
 import javax.jcr.nodetype.NodeTypeManager;
 import javax.jcr.nodetype.PropertyDefinition;
 import net.jcip.annotations.Immutable;
+import org.jboss.dna.common.util.CheckArg;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.property.Name;
 import org.jboss.dna.graph.property.NameFactory;
@@ -538,4 +539,49 @@
     public PropertyDefinitionTemplate createPropertyDefinitionTemplate() throws RepositoryException {
         return new JcrPropertyDefinitionTemplate(context());
     }
+
+    /**
+     * Determine whether the primary type or mixins are directly or indirectly derived from a node type with one of the supplied
+     * names.
+     * 
+     * @param primaryTypeName the primary type being checked (never <code>null</code>)
+     * @param mixinNames the mixins being checked (may be <code>null</code>)
+     * @param superTypeNames the names of the node types the primary type and mixins are tested against (never <code>null</code>)
+     * @return <code>true</code> if the primary type or one of the mixins are derived from one of the type names
+     * @throws RepositoryException if there is an exception obtaining node types
+     * @throws IllegalArgumentException if <code>primaryTypeProperty</code> is <code>null</code>
+     */
+    public boolean isDerivedFrom( String primaryTypeName,
+                                  String[] mixinNames,
+                                  String[] superTypeNames ) throws RepositoryException {
+        CheckArg.isNotNull(primaryTypeName, "primaryTypeName");
+        CheckArg.isNotNull(superTypeNames, "superTypeNames");
+
+        NameFactory nameFactory = context().getValueFactories().getNameFactory();
+        Name[] typeNames = nameFactory.create(superTypeNames);
+
+        // first check primary type
+        JcrNodeType primaryType = getNodeType(primaryTypeName);
+
+        for (Name typeName : typeNames) {
+            if (primaryType.isNodeType(typeName)) {
+                return true;
+            }
+        }
+
+        // now check mixins
+        if (mixinNames != null) {
+            for (String mixin : mixinNames) {
+                JcrNodeType mixinType = getNodeType(mixin);
+
+                for (Name typeName : typeNames) {
+                    if (mixinType.isNodeType(typeName)) {
+                        return true;
+                    }
+                }
+            }
+        }
+
+        return false;
+    }
 }
